#! /bin/sh

exec >Makefile 3>all-src.c

echo "RM=rm -f"
echo "AR=ar"
echo "CC=cc"
echo "CFLAGS="
echo "LIBWOFS=libwofs.a"
echo "OBJPREFIX="
echo "WOFSROOT=."
echo

cd src

echo 'WRONCEFS_OBJS=\'
for SRC in *.c
do
	echo ' $(OBJPREFIX)'"${SRC%*.c}.o \\"
	echo "#include \"src/$SRC\"" >&3
done
echo

echo 'all: $(LIBWOFS)'
echo

echo 'clean:'
echo '	-$(RM) $(LIBWOFS) $(WRONCEFS_OBJS)'
echo

echo '$(LIBWOFS): $(WRONCEFS_OBJS)'
echo '	$(AR) r $(LIBWOFS) $(WRONCEFS_OBJS)'
echo

echo 'emit_objects:'
echo '	@echo $(WRONCEFS_OBJS)'
echo

for SRC in *.c
do
	echo '$(OBJPREFIX)'"${SRC%*.c}.o:"
	echo '	$(CC) $(CFLAGS) -I$(WOFSROOT)/include -o $(OBJPREFIX)'"${SRC%*.c}.o"' -c $(WOFSROOT)/src/'"$SRC"
	echo
done

echo 'dep:'
echo '	echo "## Generated file, do not edit" >Makefile.dep'
echo '	echo $(LIBWOFS): $(WRONCEFS_OBJS) >>Makefile.dep'
for SRC in *.c
do
	echo '	$(CC) $(CFLAGS) -I$(WOFSROOT)/include -MT $(OBJPREFIX)'"${SRC%*.c}.o"' -MM $(WOFSROOT)/src/'"$SRC >>Makefile.dep"
done
echo

echo '-include Makefile.dep'
echo
