/*
Write-once filesystem

Copyright (c) 2022 Aron Barath
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. Neither the name of the Author nor the names of contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

Source code: svn://svn.repo.hu/wroncefs/trunk
Contact the author: aron-dev@mailbox.org
*/

#ifndef TEST_TEST_H
#define TEST_TEST_H

#include <stdint.h>

#define CHECK(_expected_, _expr_) \
	do \
	{ \
		if((_expected_)!=(_expr_)) \
		{ \
			fprintf(stderr, "FAIL in line %lu: '%s' is expected to be " \
				"'%s'\n", (unsigned long)(__LINE__), #_expr_, #_expected_); \
			return 1; \
		} \
	} \
	while(0)

#define CHECK_NE(_not_expected_, _expr_) \
	do \
	{ \
		if((_not_expected_)==(_expr_)) \
		{ \
			fprintf(stderr, "FAIL in line %lu: '%s' is not expected to be " \
				"'%s'\n", (unsigned long)(__LINE__), #_expr_, \
				(#_not_expected_)); \
			return 1; \
		} \
	} \
	while(0)

int run_tests(const uint16_t nblocks, const uint8_t blkszsh);
int run_case1(const uint16_t nblocks, const uint8_t blkszsh);

#endif /* TEST_TEST_H */
