CFLAGS=-g -I. -I../../include

all: libwofs.a tester

check: all
	./tester

libwofs.a:
	$(MAKE) -f ../../Makefile "CFLAGS=$(CFLAGS)" WOFSROOT=../.. OBJPREFIX=wofs_ $@

wofs_%.o:
	$(MAKE) -f ../../Makefile "CFLAGS=$(CFLAGS)" WOFSROOT=../.. OBJPREFIX=wofs_ $@

dep:
	$(MAKE) -f ../../Makefile "CFLAGS=$(CFLAGS)" WOFSROOT=../.. OBJPREFIX=wofs_ dep
	$(CC) $(CFLAGS) -MM ../main.c >>Makefile.dep
	$(CC) $(CFLAGS) -MM ../io.c >>Makefile.dep
	$(CC) $(CFLAGS) -MM ../run.c >>Makefile.dep
	$(CC) $(CFLAGS) -MM ../case1.c >>Makefile.dep

clean:
	rm -rf tester libwofs.a
	rm -rf *.o
	rm -rf data_*.img
	rm -rf case*.img

-include Makefile.dep

tester: main.o io.o run.o case1.o libwofs.a
	$(CC) -o $@ $^

main.o: ../main.c
	$(CC) $(CFLAGS) -c $< -o $@

io.o: ../io.c
	$(CC) $(CFLAGS) -c $< -o $@

run.o: ../run.c
	$(CC) $(CFLAGS) -c $< -o $@

case1.o: ../case1.c
	$(CC) $(CFLAGS) -c $< -o $@
